import React from 'react';
import { MuiThemeContextTypes } from './index';
import { MuiThemeProviderInner, deepMerge } from 'muix-styles';
class MuiThemeProvider extends React.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.localTheme = this.mergeOuterLocalTheme(context.theme);
    }
    getChildContext() {
        return { theme: this.localTheme };
    }
    mergeOuterLocalTheme(outerTheme) {
        const { props: { theme } } = this;
        if (typeof theme === 'function')
            return theme(outerTheme);
        if (outerTheme && theme.overrides)
            deepMerge(theme.overrides, outerTheme.overrides);
        return theme;
    }
    render() {
        const child = React.Children.only(this.props.children);
        return MuiThemeProviderInner ? <MuiThemeProviderInner theme={this.localTheme}>{child} </MuiThemeProviderInner> : child;
    }
}
MuiThemeProvider.childContextTypes = MuiThemeContextTypes;
MuiThemeProvider.contextTypes = MuiThemeContextTypes;
export default MuiThemeProvider;
